<?php # Script 17.x - se_index.php
// This page indexes the site!

// Created by Larry Ullman, www.LarryUllman.com
// Associated with the content from Chapter 17 of the book "PHP and MySQL for Dynamic Web Sites: Visual QuickPro Guide (4th Edition)".
// The other scripts and SQL commands that go with this code can be downloaded from the book's corresponding Web site at www.LarryUllman.com.

// Things to change in the real-world:
// - Use prepared statements.
// - Use custom functions.

// Need the database connection:
require ('../mysqli_connect.php');

// Get the thread IDs:
$query = 'SELECT thread_id FROM threads';
$result = mysqli_query($dbc, $query);
while (list($tid) = mysqli_fetch_array($result, MYSQLI_NUM)) {
	
	// Need a new words array:
	$words = array();
	
	// URL to be read:
	$se_url = 'http://www.example.com/se_read.php?tid=' . $tid;
	
	// Access the URL:
	$content = file_get_contents($se_url);
	
	// Strip tags, just in case:
	$content = strip_tags($content);

	// Convert to lowercase:
	$content = strtolower($content);
	
	// Break the content into words:
	preg_match_all('/\b\w+\b/', $content, $output);
	
	// Loop through the words to count them:
	foreach ($output[0] as $word) {
		if (strlen($word) > 3) {
			if (isset($words[$word])) { 
				$words[$word]++;
			} else {
				$words[$word] = 1;
			}
		}
	}
	
	// Get the page ID from the database:
	$q = "SELECT page_id FROM se_pages WHERE page_url='http://www.example.com/read.php?tid=$tid'" ;
	$r = mysqli_query($dbc, $q);
	if (mysqli_num_rows($r) == 1) { // Get the page ID.
		list($page_id) = mysqli_fetch_array($r, MYSQLI_NUM);
	} else { // Create the page ID.
		$q = "INSERT INTO se_pages (page_url) VALUES ('http://www.example.com/read.php?tid=$tid')";
		$r = mysqli_query($dbc, $q);
		$page_id = mysqli_insert_id($dbc);
	}
	
	// Populate the database:
	foreach ($words as $word => $frequency) {
		
		// Get the word ID from the database:
		$q = 'SELECT word_id FROM se_words WHERE word="' . mysqli_real_escape_string($dbc, $word) . '"' ;
		$r = mysqli_query($dbc, $q);
		if (mysqli_num_rows($r) == 1) { // Get the word ID.
			list($word_id) = mysqli_fetch_array($r, MYSQLI_NUM);
		} else { // Create the word ID.
			$q = 'INSERT INTO se_words (word) VALUES ("' . mysqli_real_escape_string($dbc, $word) . '")';
			$r = mysqli_query($dbc, $q);
			$word_id = mysqli_insert_id($dbc);
		}
		
		// Populate the pages_words table:
		$q = "REPLACE INTO se_pages_words VALUES ($page_id, $word_id, $frequency)";
		$r = mysqli_query($dbc, $q);
				
	}

} // End of WHILE loop.
		
?>